std::unordered_set< _Value, _Hash, _Pred, _Alloc > Class Template Reference
Containers » Unordered Associative

`#include <unordered_set>`

## Public Types

using | insert_return_type = typename _Hashtable::insert_return_type
using | node_type = typename _Hashtable::node_type
typedef _Hashtable::key_type | key_type
typedef _Hashtable::value_type | value_type
typedef _Hashtable::hasher | hasher
typedef _Hashtable::key_equal | key_equal
typedef _Hashtable::allocator_type | allocator_type
typedef _Hashtable::pointer | pointer
typedef _Hashtable::const_pointer | const_pointer
typedef _Hashtable::reference | reference
typedef _Hashtable::const_reference | const_reference
typedef _Hashtable::iterator | iterator
typedef _Hashtable::const_iterator | const_iterator
typedef _Hashtable::local_iterator | local_iterator
typedef _Hashtable::const_local_iterator | const_local_iterator
typedef _Hashtable::size_type | size_type
typedef _Hashtable::difference_type | difference_type

## Public Member Functions

| unordered_set ()=default
template<typename _InputIterator >
| unordered_set (_InputIterator __first, _InputIterator __last, size_type __n, const allocator_type &__a)
template<typename _InputIterator >
| unordered_set (_InputIterator __first, _InputIterator __last, size_type __n, const hasher &__hf, const allocator_type &__a)
template<typename _InputIterator >
| unordered_set (_InputIterator __first, _InputIterator __last, size_type __n=0, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
| unordered_set (const allocator_type &__a)
| unordered_set (const unordered_set &)=default
| unordered_set (const unordered_set &__uset, const allocator_type &__a)
| unordered_set (initializer_list< value_type > __l, size_type __n, const allocator_type &__a)
| unordered_set (initializer_list< value_type > __l, size_type __n, const hasher &__hf, const allocator_type &__a)
| unordered_set (initializer_list< value_type > __l, size_type __n=0, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
| unordered_set (size_type __n, const allocator_type &__a)
| unordered_set (size_type __n, const hasher &__hf, const allocator_type &__a)
| unordered_set (size_type __n, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
| unordered_set (unordered_set &&)=default
| unordered_set (unordered_set &&__uset, const allocator_type &__a) noexcept(noexcept(_Hashtable(std::move(__uset._M_h), __a)))
size_type | bucket (const key_type &__key) const
size_type | bucket_count () const noexcept
size_type | bucket_size (size_type __n) const
const_iterator | cbegin () const noexcept
const_iterator | cend () const noexcept
void | clear () noexcept
template<typename... _Args>
std::pair< iterator, bool > | emplace (_Args &&... __args)
template<typename... _Args>
iterator | emplace_hint (const_iterator __pos, _Args &&... __args)
bool | empty () const noexcept
size_type | erase (const key_type &__x)
iterator | erase (const_iterator __first, const_iterator __last)
node_type | extract (const key_type &__key)
node_type | extract (const_iterator __pos)
allocator_type | get_allocator () const noexcept
hasher | hash_function () const
template<typename _InputIterator >
void | insert (_InputIterator __first, _InputIterator __last)
iterator | insert (const_iterator, node_type &&__nh)
void | insert (initializer_list< value_type > __l)
insert_return_type | insert (node_type &&__nh)
key_equal | key_eq () const
float | load_factor () const noexcept
size_type | max_bucket_count () const noexcept
float | max_load_factor () const noexcept
void | max_load_factor (float __z)
size_type | max_size () const noexcept
template<typename _H2 , typename _P2 >
void | merge (unordered_multiset< _Value, _H2, _P2, _Alloc > &&__source)
template<typename _H2 , typename _P2 >
void | merge (unordered_multiset< _Value, _H2, _P2, _Alloc > &__source)
template<typename _H2 , typename _P2 >
void | merge (unordered_set< _Value, _H2, _P2, _Alloc > &&__source)
template<typename _H2 , typename _P2 >
void | merge (unordered_set< _Value, _H2, _P2, _Alloc > &__source)
unordered_set & | operator= (const unordered_set &)=default
unordered_set & | operator= (initializer_list< value_type > __l)
unordered_set & | operator= (unordered_set &&)=default
void | rehash (size_type __n)
void | reserve (size_type __n)
size_type | size () const noexcept
void | swap (unordered_set &__x) noexcept(noexcept(_M_h.swap(__x._M_h)))
iterator | begin () noexcept
const_iterator | begin () const noexcept
iterator | end () noexcept
const_iterator | end () const noexcept
std::pair< iterator, bool > | insert (const value_type &__x)
std::pair< iterator, bool > | insert (value_type &&__x)
iterator | insert (const_iterator __hint, const value_type &__x)
iterator | insert (const_iterator __hint, value_type &&__x)
iterator | erase (const_iterator __position)
iterator | erase (iterator __position)
iterator | find (const key_type &__x)
template<typename _Kt >
auto | find (const _Kt &__k) -> decltype(_M_h._M_find_tr(__k))
const_iterator | find (const key_type &__x) const
template<typename _Kt >
auto | find (const _Kt &__k) const -> decltype(_M_h._M_find_tr(__k))
size_type | count (const key_type &__x) const
template<typename _Kt >
auto | count (const _Kt &__k) const -> decltype(_M_h._M_count_tr(__k))
bool | contains (const key_type &__x) const
template<typename _Kt >
auto | contains (const _Kt &__k) const -> decltype(_M_h._M_find_tr(__k), void(), true)
std::pair< iterator, iterator > | equal_range (const key_type &__x)
template<typename _Kt >
auto | equal_range (const _Kt &__k) -> decltype(_M_h._M_equal_range_tr(__k))
std::pair< const_iterator, const_iterator > | equal_range (const key_type &__x) const
template<typename _Kt >
auto | equal_range (const _Kt &__k) const -> decltype(_M_h._M_equal_range_tr(__k))
local_iterator | begin (size_type __n)
const_local_iterator | begin (size_type __n) const
const_local_iterator | cbegin (size_type __n) const
local_iterator | end (size_type __n)
const_local_iterator | end (size_type __n) const
const_local_iterator | cend (size_type __n) const

## Friends

template<typename _Value1 , typename _Hash1 , typename _Pred1 , typename _Alloc1 >
bool | operator== (const unordered_set< _Value1, _Hash1, _Pred1, _Alloc1 > &, const unordered_set< _Value1, _Hash1, _Pred1, _Alloc1 > &)
template<typename , typename , typename >
class | std::_Hash_merge_helper

## Detailed Description

template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>
class std::unordered_set< _Value, _Hash, _Pred, _Alloc >

A standard container composed of unique keys (containing at most one of each key value) in which the elements' keys are the elements themselves.

Since
  C++11

Template Parameters

  _Value | Type of key objects.
  _Hash | Hashing function object type, defaults to hash<_Value>.
  _Pred | Predicate function object type, defaults to equal_to<_Value>.
  _Alloc | Allocator type, defaults to allocator<_Key>.

Meets the requirements of a container, and unordered associative container

Base is _Hashtable, dispatched at compile time via template alias __uset_hashtable.

Definition at line 99 of file unordered_set.h.

## Member Typedef Documentation

## allocator_type

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

typedef _Hashtable::allocator_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::allocator_type

Public typedefs.

Definition at line 112 of file unordered_set.h.

## const_iterator

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

typedef _Hashtable::const_iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::const_iterator

Iterator-related typedefs.

Definition at line 122 of file unordered_set.h.

## const_local_iterator

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

typedef _Hashtable::const_local_iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::const_local_iterator

Iterator-related typedefs.

Definition at line 124 of file unordered_set.h.

## const_pointer

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

typedef _Hashtable::const_pointer std::unordered_set< _Value, _Hash, _Pred, _Alloc >::const_pointer

Iterator-related typedefs.

Definition at line 118 of file unordered_set.h.

## const_reference

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

typedef _Hashtable::const_reference std::unordered_set< _Value, _Hash, _Pred, _Alloc >::const_reference

Iterator-related typedefs.

Definition at line 120 of file unordered_set.h.

## difference_type

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

typedef _Hashtable::difference_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::difference_type

Iterator-related typedefs.

Definition at line 126 of file unordered_set.h.

## hasher

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

typedef _Hashtable::hasher std::unordered_set< _Value, _Hash, _Pred, _Alloc >::hasher

Public typedefs.

Definition at line 110 of file unordered_set.h.

## insert_return_type

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

using std::unordered_set< _Value, _Hash, _Pred, _Alloc >::insert_return_type = typename _Hashtable::insert_return_type

Definition at line 131 of file unordered_set.h.

## iterator

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

typedef _Hashtable::iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::iterator

Iterator-related typedefs.

Definition at line 121 of file unordered_set.h.

## key_equal

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

typedef _Hashtable::key_equal std::unordered_set< _Value, _Hash, _Pred, _Alloc >::key_equal

Public typedefs.

Definition at line 111 of file unordered_set.h.

## key_type

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

typedef _Hashtable::key_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::key_type

Public typedefs.

Definition at line 108 of file unordered_set.h.

## local_iterator

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

typedef _Hashtable::local_iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::local_iterator

Iterator-related typedefs.

Definition at line 123 of file unordered_set.h.

## node_type

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

using std::unordered_set< _Value, _Hash, _Pred, _Alloc >::node_type = typename _Hashtable::node_type

Definition at line 130 of file unordered_set.h.

## pointer

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

typedef _Hashtable::pointer std::unordered_set< _Value, _Hash, _Pred, _Alloc >::pointer

Iterator-related typedefs.

Definition at line 117 of file unordered_set.h.

## reference

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

typedef _Hashtable::reference std::unordered_set< _Value, _Hash, _Pred, _Alloc >::reference

Iterator-related typedefs.

Definition at line 119 of file unordered_set.h.

## size_type

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

typedef _Hashtable::size_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::size_type

Iterator-related typedefs.

Definition at line 125 of file unordered_set.h.

## value_type

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

typedef _Hashtable::value_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::value_type

Public typedefs.

Definition at line 109 of file unordered_set.h.

## Constructor & Destructor Documentation

## unordered_set() [1/15]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

std::unordered_set< _Value, _Hash, _Pred, _Alloc >::unordered_set | ( |  | ) |

default

Default constructor.

## unordered_set() [2/15]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

std::unordered_set< _Value, _Hash, _Pred, _Alloc >::unordered_set | ( | size_type | __n,
|  | const hasher & | __hf = `hasher()`,
|  | const key_equal & | __eql = `key_equal()`,
|  | const allocator_type & | __a = `allocator_type()`
| ) |  |

inline explicit

Default constructor creates no elements.

Parameters

  __n | Minimal initial number of buckets.
  __hf | A hash functor.
  __eql | A key equality functor.
  __a | An allocator object.

Definition at line 147 of file unordered_set.h.

## unordered_set() [3/15]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>
template<typename _InputIterator >

std::unordered_set< _Value, _Hash, _Pred, _Alloc >::unordered_set | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | size_type | __n = `0`,
|  | const hasher & | __hf = `hasher()`,
|  | const key_equal & | __eql = `key_equal()`,
|  | const allocator_type & | __a = `allocator_type()`
| ) |  |

inline

Builds an unordered_set from a range.

Parameters

  __first | An input iterator.
  __last | An input iterator.
  __n | Minimal initial number of buckets.
  __hf | A hash functor.
  __eql | A key equality functor.
  __a | An allocator object.

Create an unordered_set consisting of copies of the elements from [__first,__last). This is linear in N (where N is distance(__first,__last)).

Definition at line 168 of file unordered_set.h.

## unordered_set() [4/15]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

std::unordered_set< _Value, _Hash, _Pred, _Alloc >::unordered_set | ( | const unordered_set< _Value, _Hash, _Pred, _Alloc > & |  | ) |

default

Copy constructor.

## unordered_set() [5/15]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

std::unordered_set< _Value, _Hash, _Pred, _Alloc >::unordered_set | ( | unordered_set< _Value, _Hash, _Pred, _Alloc > && |  | ) |

default

Move constructor.

## unordered_set() [6/15]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

std::unordered_set< _Value, _Hash, _Pred, _Alloc >::unordered_set | ( | const allocator_type & | __a | ) |

inline explicit

Creates an unordered_set with no elements.

Parameters

  __a | An allocator object.

Definition at line 187 of file unordered_set.h.

## unordered_set() [7/15]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

std::unordered_set< _Value, _Hash, _Pred, _Alloc >::unordered_set | ( | const unordered_set< _Value, _Hash, _Pred, _Alloc > & | __uset,
|  | const allocator_type & | __a
| ) |  |

inline

Definition at line 196 of file unordered_set.h.

## unordered_set() [8/15]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

std::unordered_set< _Value, _Hash, _Pred, _Alloc >::unordered_set | ( | unordered_set< _Value, _Hash, _Pred, _Alloc > && | __uset,
|  | const allocator_type & | __a
| ) |  |

inline noexcept

Definition at line 206 of file unordered_set.h.

## unordered_set() [9/15]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

std::unordered_set< _Value, _Hash, _Pred, _Alloc >::unordered_set | ( | initializer_list< value_type > | __l,
|  | size_type | __n = `0`,
|  | const hasher & | __hf = `hasher()`,
|  | const key_equal & | __eql = `key_equal()`,
|  | const allocator_type & | __a = `allocator_type()`
| ) |  |

inline

Builds an unordered_set from an initializer_list.

Parameters

  __l | An initializer_list.
  __n | Minimal initial number of buckets.
  __hf | A hash functor.
  __eql | A key equality functor.
  __a | An allocator object.

Create an unordered_set consisting of copies of the elements in the list. This is linear in N (where N is __l.size()).

Definition at line 223 of file unordered_set.h.

## unordered_set() [10/15]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

std::unordered_set< _Value, _Hash, _Pred, _Alloc >::unordered_set | ( | size_type | __n,
|  | const allocator_type & | __a
| ) |  |

inline

Definition at line 231 of file unordered_set.h.

## unordered_set() [11/15]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

std::unordered_set< _Value, _Hash, _Pred, _Alloc >::unordered_set | ( | size_type | __n,
|  | const hasher & | __hf,
|  | const allocator_type & | __a
| ) |  |

inline

Definition at line 235 of file unordered_set.h.

## unordered_set() [12/15]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>
template<typename _InputIterator >

std::unordered_set< _Value, _Hash, _Pred, _Alloc >::unordered_set | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | size_type | __n,
|  | const allocator_type & | __a
| ) |  |

inline

Definition at line 241 of file unordered_set.h.

## unordered_set() [13/15]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>
template<typename _InputIterator >

std::unordered_set< _Value, _Hash, _Pred, _Alloc >::unordered_set | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | size_type | __n,
|  | const hasher & | __hf,
|  | const allocator_type & | __a
| ) |  |

inline

Definition at line 248 of file unordered_set.h.

## unordered_set() [14/15]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

std::unordered_set< _Value, _Hash, _Pred, _Alloc >::unordered_set | ( | initializer_list< value_type > | __l,
|  | size_type | __n,
|  | const allocator_type & | __a
| ) |  |

inline

Definition at line 254 of file unordered_set.h.

## unordered_set() [15/15]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

std::unordered_set< _Value, _Hash, _Pred, _Alloc >::unordered_set | ( | initializer_list< value_type > | __l,
|  | size_type | __n,
|  | const hasher & | __hf,
|  | const allocator_type & | __a
| ) |  |

inline

Definition at line 260 of file unordered_set.h.

## Member Function Documentation

## begin() [1/4]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

const_iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::begin | ( |  | ) | const

inline noexcept

Returns a read-only (constant) iterator that points to the first element in the unordered_set.

Definition at line 326 of file unordered_set.h.

## begin() [2/4]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::begin | ( |  | ) |

inline noexcept

Returns a read-only (constant) iterator that points to the first element in the unordered_set.

Definition at line 322 of file unordered_set.h.

## begin() [3/4]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

local_iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::begin | ( | size_type | __n | ) |

inline

Returns a read-only (constant) iterator pointing to the first bucket element.

Parameters

  __n | The bucket index.

Returns
  A read-only local iterator.

Definition at line 790 of file unordered_set.h.

## begin() [4/4]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

const_local_iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::begin | ( | size_type | __n | ) | const

inline

Returns a read-only (constant) iterator pointing to the first bucket element.

Parameters

  __n | The bucket index.

Returns
  A read-only local iterator.

Definition at line 794 of file unordered_set.h.

## bucket()

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

size_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::bucket | ( | const key_type & | __key | ) | const

inline

Definition at line 779 of file unordered_set.h.

## bucket_count()

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

size_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::bucket_count | ( |  | ) | const

inline noexcept

Returns the number of buckets of the unordered_set.

Definition at line 756 of file unordered_set.h.

## bucket_size()

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

size_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::bucket_size | ( | size_type | __n | ) | const

inline

Definition at line 770 of file unordered_set.h.

## cbegin() [1/2]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

const_iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::cbegin | ( |  | ) | const

inline noexcept

Returns a read-only (constant) iterator that points to the first element in the unordered_set.

Definition at line 349 of file unordered_set.h.

## cbegin() [2/2]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

const_local_iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::cbegin | ( | size_type | __n | ) | const

inline

Returns a read-only (constant) iterator pointing to the first bucket element.

Parameters

  __n | The bucket index.

Returns
  A read-only local iterator.

Definition at line 798 of file unordered_set.h.

## cend() [1/2]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

const_iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::cend | ( |  | ) | const

inline noexcept

Returns a read-only (constant) iterator that points one past the last element in the unordered_set.

Definition at line 357 of file unordered_set.h.

## cend() [2/2]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

const_local_iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::cend | ( | size_type | __n | ) | const

inline

Returns a read-only (constant) iterator pointing to one past the last bucket elements.

Parameters

  __n | The bucket index.

Returns
  A read-only local iterator.

Definition at line 818 of file unordered_set.h.

## clear()

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

void std::unordered_set< _Value, _Hash, _Pred, _Alloc >::clear | ( |  | ) |

inline noexcept

Erases all elements in an unordered_set. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 575 of file unordered_set.h.

## contains() [1/2]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>
template<typename _Kt >

auto std::unordered_set< _Value, _Hash, _Pred, _Alloc >::contains | ( | const _Kt & | __k | ) | const -> decltype(_M_h._M_find_tr(__k), void(), true)

inline

Finds whether an element with the given key exists.

Parameters

  __x | Key of elements to be located.

Returns
  True if there is any element with the specified key.

Definition at line 712 of file unordered_set.h.

## contains() [2/2]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

bool std::unordered_set< _Value, _Hash, _Pred, _Alloc >::contains | ( | const key_type & | __x | ) | const

inline

Finds whether an element with the given key exists.

Parameters

  __x | Key of elements to be located.

Returns
  True if there is any element with the specified key.

Definition at line 707 of file unordered_set.h.

## count() [1/2]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>
template<typename _Kt >

auto std::unordered_set< _Value, _Hash, _Pred, _Alloc >::count | ( | const _Kt & | __k | ) | const -> decltype(_M_h._M_count_tr(__k))

inline

Finds the number of elements.

Parameters

  __x | Element to located.

Returns
  Number of elements with specified key.

This function only makes sense for unordered_multisets; for unordered_set the result will either be 0 (not present) or 1 (present).

Definition at line 693 of file unordered_set.h.

## count() [2/2]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

size_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::count | ( | const key_type & | __x | ) | const

inline

Finds the number of elements.

Parameters

  __x | Element to located.

Returns
  Number of elements with specified key.

This function only makes sense for unordered_multisets; for unordered_set the result will either be 0 (not present) or 1 (present).

Definition at line 687 of file unordered_set.h.

## emplace()

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>
template<typename... _Args>

std::pair< iterator, bool > std::unordered_set< _Value, _Hash, _Pred, _Alloc >::emplace | ( | _Args &&... | __args | ) |

inline

Attempts to build and insert an element into the unordered_set.

Parameters

  __args | Arguments used to generate an element.

Returns
  A pair, of which the first element is an iterator that points to the possibly inserted element, and the second is a bool that is true if the element was actually inserted.

This function attempts to build and insert an element into the unordered_set. An unordered_set relies on unique keys and thus an element is only inserted if it is not already present in the unordered_set.

Insertion requires amortized constant time.

Definition at line 379 of file unordered_set.h.

## emplace_hint()

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>
template<typename... _Args>

iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::emplace_hint | ( | const_iterator | __pos,
|  | _Args &&... | __args
| ) |  |

inline

Attempts to insert an element into the unordered_set.

Parameters

  __pos | An iterator that serves as a hint as to where the element should be inserted.
  __args | Arguments used to generate the element to be inserted.

Returns
  An iterator that points to the element with key equivalent to the one generated from __args (may or may not be the element itself).

This function is not concerned about whether the insertion took place, and thus does not return a boolean like the single-argument emplace() does. Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

For more on hinting, see: https://gcc.gnu.org/onlinedocs/libstdc++/manual/associative.html#containers.associative.insert_hints

Insertion requires amortized constant time.

Definition at line 405 of file unordered_set.h.

## empty()

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

bool std::unordered_set< _Value, _Hash, _Pred, _Alloc >::empty | ( |  | ) | const

inline noexcept

Returns true if the unordered_set is empty.

Definition at line 301 of file unordered_set.h.

## end() [1/4]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

const_iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::end | ( |  | ) | const

inline noexcept

Returns a read-only (constant) iterator that points one past the last element in the unordered_set.

Definition at line 340 of file unordered_set.h.

## end() [2/4]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::end | ( |  | ) |

inline noexcept

Returns a read-only (constant) iterator that points one past the last element in the unordered_set.

Definition at line 336 of file unordered_set.h.

Referenced by std::unordered_set< _Value, _Hash, _Pred, _Alloc >::extract().

## end() [3/4]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

local_iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::end | ( | size_type | __n | ) |

inline

Returns a read-only (constant) iterator pointing to one past the last bucket elements.

Parameters

  __n | The bucket index.

Returns
  A read-only local iterator.

Definition at line 810 of file unordered_set.h.

## end() [4/4]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

const_local_iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::end | ( | size_type | __n | ) | const

inline

Returns a read-only (constant) iterator pointing to one past the last bucket elements.

Parameters

  __n | The bucket index.

Returns
  A read-only local iterator.

Definition at line 814 of file unordered_set.h.

## equal_range() [1/4]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>
template<typename _Kt >

auto std::unordered_set< _Value, _Hash, _Pred, _Alloc >::equal_range | ( | const _Kt & | __k | ) | -> decltype(_M_h._M_equal_range_tr(__k))

inline

Finds a subsequence matching given key.

Parameters

  __x | Key to be located.

Returns
  Pair of iterators that possibly points to the subsequence matching given key.

This function probably only makes sense for multisets.

Definition at line 734 of file unordered_set.h.

## equal_range() [2/4]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>
template<typename _Kt >

auto std::unordered_set< _Value, _Hash, _Pred, _Alloc >::equal_range | ( | const _Kt & | __k | ) | const -> decltype(_M_h._M_equal_range_tr(__k))

inline

Finds a subsequence matching given key.

Parameters

  __x | Key to be located.

Returns
  Pair of iterators that possibly points to the subsequence matching given key.

This function probably only makes sense for multisets.

Definition at line 746 of file unordered_set.h.

## equal_range() [3/4]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

std::pair< iterator, iterator > std::unordered_set< _Value, _Hash, _Pred, _Alloc >::equal_range | ( | const key_type & | __x | ) |

inline

Finds a subsequence matching given key.

Parameters

  __x | Key to be located.

Returns
  Pair of iterators that possibly points to the subsequence matching given key.

This function probably only makes sense for multisets.

Definition at line 728 of file unordered_set.h.

## equal_range() [4/4]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

std::pair< const_iterator, const_iterator > std::unordered_set< _Value, _Hash, _Pred, _Alloc >::equal_range | ( | const key_type & | __x | ) | const

inline

Finds a subsequence matching given key.

Parameters

  __x | Key to be located.

Returns
  Pair of iterators that possibly points to the subsequence matching given key.

This function probably only makes sense for multisets.

Definition at line 740 of file unordered_set.h.

## erase() [1/4]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

size_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::erase | ( | const key_type & | __x | ) |

inline

Erases elements according to the provided key.

Parameters

  __x | Key of element to be erased.

Returns
  The number of elements erased.

This function erases all the elements located by the given key from an unordered_set. For an unordered_set the result of this function can only be 0 (not present) or 1 (present). Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 547 of file unordered_set.h.

## erase() [2/4]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::erase | ( | const_iterator | __first,
|  | const_iterator | __last
| ) |  |

inline

Erases a [__first,__last) range of elements from an unordered_set.

Parameters

  __first | Iterator pointing to the start of the range to be erased.
  __last | Iterator pointing to the end of the range to be erased.

Returns
  The iterator __last.

This function erases a sequence of elements from an unordered_set. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 565 of file unordered_set.h.

## erase() [3/4]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::erase | ( | const_iterator | __position | ) |

inline

Erases an element from an unordered_set.

Parameters

  __position | An iterator pointing to the element to be erased.

Returns
  An iterator pointing to the element immediately following __position prior to the element being erased. If no such element exists, end() is returned.

This function erases an element, pointed to by the given iterator, from an unordered_set. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 525 of file unordered_set.h.

## erase() [4/4]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::erase | ( | iterator | __position | ) |

inline

Erases an element from an unordered_set.

Parameters

  __position | An iterator pointing to the element to be erased.

Returns
  An iterator pointing to the element immediately following __position prior to the element being erased. If no such element exists, end() is returned.

This function erases an element, pointed to by the given iterator, from an unordered_set. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 530 of file unordered_set.h.

## extract() [1/2]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

node_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::extract | ( | const key_type & | __key | ) |

inline

Extract a node.

Definition at line 496 of file unordered_set.h.

## extract() [2/2]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

node_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::extract | ( | const_iterator | __pos | ) |

inline

Extract a node.

Definition at line 488 of file unordered_set.h.

References std::unordered_set< _Value, _Hash, _Pred, _Alloc >::end().

## find() [1/4]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>
template<typename _Kt >

auto std::unordered_set< _Value, _Hash, _Pred, _Alloc >::find | ( | const _Kt & | __k | ) | -> decltype(_M_h._M_find_tr(__k))

inline

Tries to locate an element in an unordered_set.

Parameters

  __x | Element to be located.

Returns
  Iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns an iterator pointing to the sought after element. If unsuccessful it returns the past-the-end ( `end()` ) iterator.

Definition at line 658 of file unordered_set.h.

## find() [2/4]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>
template<typename _Kt >

auto std::unordered_set< _Value, _Hash, _Pred, _Alloc >::find | ( | const _Kt & | __k | ) | const -> decltype(_M_h._M_find_tr(__k))

inline

Tries to locate an element in an unordered_set.

Parameters

  __x | Element to be located.

Returns
  Iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns an iterator pointing to the sought after element. If unsuccessful it returns the past-the-end ( `end()` ) iterator.

Definition at line 670 of file unordered_set.h.

## find() [3/4]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::find | ( | const key_type & | __x | ) |

inline

Tries to locate an element in an unordered_set.

Parameters

  __x | Element to be located.

Returns
  Iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns an iterator pointing to the sought after element. If unsuccessful it returns the past-the-end ( `end()` ) iterator.

Definition at line 652 of file unordered_set.h.

## find() [4/4]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

const_iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::find | ( | const key_type & | __x | ) | const

inline

Tries to locate an element in an unordered_set.

Parameters

  __x | Element to be located.

Returns
  Iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns an iterator pointing to the sought after element. If unsuccessful it returns the past-the-end ( `end()` ) iterator.

Definition at line 664 of file unordered_set.h.

## get_allocator()

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

allocator_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::get_allocator | ( |  | ) | const

inline noexcept

Returns the allocator object used by the unordered_set.

Definition at line 294 of file unordered_set.h.

## hash_function()

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

hasher std::unordered_set< _Value, _Hash, _Pred, _Alloc >::hash_function | ( |  | ) | const

inline

Returns the hash functor object with which the unordered_set was constructed.

Definition at line 628 of file unordered_set.h.

## insert() [1/8]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>
template<typename _InputIterator >

void std::unordered_set< _Value, _Hash, _Pred, _Alloc >::insert | ( | _InputIterator | __first,
|  | _InputIterator | __last
| ) |  |

inline

A template function that attempts to insert a range of elements.

Parameters

  __first | Iterator pointing to the start of the range to be inserted.
  __last | Iterator pointing to the end of the range.

Complexity similar to that of the range constructor.

Definition at line 471 of file unordered_set.h.

## insert() [2/8]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

std::pair< iterator, bool > std::unordered_set< _Value, _Hash, _Pred, _Alloc >::insert | ( | const value_type & | __x | ) |

inline

Attempts to insert an element into the unordered_set.

Parameters

  __x | Element to be inserted.

Returns
  A pair, of which the first element is an iterator that points to the possibly inserted element, and the second is a bool that is true if the element was actually inserted.

This function attempts to insert an element into the unordered_set. An unordered_set relies on unique keys and thus an element is only inserted if it is not already present in the unordered_set.

Insertion requires amortized constant time.

Definition at line 423 of file unordered_set.h.

## insert() [3/8]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::insert | ( | const_iterator | __hint,
|  | const value_type & | __x
| ) |  |

inline

Attempts to insert an element into the unordered_set.

Parameters

  __hint | An iterator that serves as a hint as to where the element should be inserted.
  __x | Element to be inserted.

Returns
  An iterator that points to the element with key of __x (may or may not be the element passed in).

This function is not concerned about whether the insertion took place, and thus does not return a boolean like the single-argument insert() does. Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

For more on hinting, see: https://gcc.gnu.org/onlinedocs/libstdc++/manual/associative.html#containers.associative.insert_hints

Insertion requires amortized constant.

Definition at line 452 of file unordered_set.h.

## insert() [4/8]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::insert | ( | const_iterator | __hint,
|  | value_type && | __x
| ) |  |

inline

Attempts to insert an element into the unordered_set.

Parameters

  __hint | An iterator that serves as a hint as to where the element should be inserted.
  __x | Element to be inserted.

Returns
  An iterator that points to the element with key of __x (may or may not be the element passed in).

This function is not concerned about whether the insertion took place, and thus does not return a boolean like the single-argument insert() does. Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

For more on hinting, see: https://gcc.gnu.org/onlinedocs/libstdc++/manual/associative.html#containers.associative.insert_hints

Insertion requires amortized constant.

Definition at line 456 of file unordered_set.h.

References std::move().

## insert() [5/8]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::insert | ( | const_iterator | ,
|  | node_type && | __nh
| ) |  |

inline

Re-insert an extracted node.

Definition at line 506 of file unordered_set.h.

References std::move().

## insert() [6/8]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

void std::unordered_set< _Value, _Hash, _Pred, _Alloc >::insert | ( | initializer_list< value_type > | __l | ) |

inline

Attempts to insert a list of elements into the unordered_set.

Parameters

  __l | A std::initializer_list<value_type> of elements to be inserted.

Complexity similar to that of the range constructor.

Definition at line 482 of file unordered_set.h.

## insert() [7/8]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

insert_return_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::insert | ( | node_type && | __nh | ) |

inline

Re-insert an extracted node.

Definition at line 501 of file unordered_set.h.

References std::move().

## insert() [8/8]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

std::pair< iterator, bool > std::unordered_set< _Value, _Hash, _Pred, _Alloc >::insert | ( | value_type && | __x | ) |

inline

Attempts to insert an element into the unordered_set.

Parameters

  __x | Element to be inserted.

Returns
  A pair, of which the first element is an iterator that points to the possibly inserted element, and the second is a bool that is true if the element was actually inserted.

This function attempts to insert an element into the unordered_set. An unordered_set relies on unique keys and thus an element is only inserted if it is not already present in the unordered_set.

Insertion requires amortized constant time.

Definition at line 427 of file unordered_set.h.

References std::move().

## key_eq()

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

key_equal std::unordered_set< _Value, _Hash, _Pred, _Alloc >::key_eq | ( |  | ) | const

inline

Returns the key comparison object with which the unordered_set was constructed.

Definition at line 634 of file unordered_set.h.

## load_factor()

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

float std::unordered_set< _Value, _Hash, _Pred, _Alloc >::load_factor | ( |  | ) | const

inline noexcept

Returns the average number of elements per bucket.

Definition at line 826 of file unordered_set.h.

## max_bucket_count()

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

size_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::max_bucket_count | ( |  | ) | const

inline noexcept

Returns the maximum number of buckets of the unordered_set.

Definition at line 761 of file unordered_set.h.

## max_load_factor() [1/2]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

float std::unordered_set< _Value, _Hash, _Pred, _Alloc >::max_load_factor | ( |  | ) | const

inline noexcept

Returns a positive number that the unordered_set tries to keep the load factor less than or equal to.

Definition at line 832 of file unordered_set.h.

## max_load_factor() [2/2]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

void std::unordered_set< _Value, _Hash, _Pred, _Alloc >::max_load_factor | ( | float | __z | ) |

inline

Change the unordered_set maximum load factor.

Parameters

  __z | The new maximum load factor.

Definition at line 840 of file unordered_set.h.

## max_size()

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

size_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::max_size | ( |  | ) | const

inline noexcept

Returns the maximum size of the unordered_set.

Definition at line 311 of file unordered_set.h.

## merge() [1/4]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>
template<typename _H2 , typename _P2 >

void std::unordered_set< _Value, _Hash, _Pred, _Alloc >::merge | ( | unordered_multiset< _Value, _H2, _P2, _Alloc > && | __source | ) |

inline

Definition at line 619 of file unordered_set.h.

## merge() [2/4]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>
template<typename _H2 , typename _P2 >

void std::unordered_set< _Value, _Hash, _Pred, _Alloc >::merge | ( | unordered_multiset< _Value, _H2, _P2, _Alloc > & | __source | ) |

inline

Definition at line 611 of file unordered_set.h.

## merge() [3/4]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>
template<typename _H2 , typename _P2 >

void std::unordered_set< _Value, _Hash, _Pred, _Alloc >::merge | ( | unordered_set< _Value, _H2, _P2, _Alloc > && | __source | ) |

inline

Definition at line 606 of file unordered_set.h.

## merge() [4/4]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>
template<typename _H2 , typename _P2 >

void std::unordered_set< _Value, _Hash, _Pred, _Alloc >::merge | ( | unordered_set< _Value, _H2, _P2, _Alloc > & | __source | ) |

inline

Definition at line 598 of file unordered_set.h.

## operator=() [1/3]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

unordered_set & std::unordered_set< _Value, _Hash, _Pred, _Alloc >::operator= | ( | const unordered_set< _Value, _Hash, _Pred, _Alloc > & |  | ) |

default

Copy assignment operator.

## operator=() [2/3]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

unordered_set & std::unordered_set< _Value, _Hash, _Pred, _Alloc >::operator= | ( | initializer_list< value_type > | __l | ) |

inline

Unordered_set list assignment operator.

Parameters

  __l | An initializer_list.

This function fills an unordered_set with copies of the elements in the initializer list __l.

Note that the assignment completely changes the unordered_set and that the resulting unordered_set's size is the same as the number of elements assigned.

Definition at line 286 of file unordered_set.h.

## operator=() [3/3]

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

unordered_set & std::unordered_set< _Value, _Hash, _Pred, _Alloc >::operator= | ( | unordered_set< _Value, _Hash, _Pred, _Alloc > && |  | ) |

default

Move assignment operator.

## rehash()

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

void std::unordered_set< _Value, _Hash, _Pred, _Alloc >::rehash | ( | size_type | __n | ) |

inline

May rehash the unordered_set.

Parameters

  __n | The new number of buckets.

Rehash will occur only if the new number of buckets respect the unordered_set maximum load factor.

Definition at line 851 of file unordered_set.h.

## reserve()

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

void std::unordered_set< _Value, _Hash, _Pred, _Alloc >::reserve | ( | size_type | __n | ) |

inline

Prepare the unordered_set for a specified number of elements.

Parameters

  __n | Number of elements required.

Same as rehash(ceil(n / max_load_factor())).

Definition at line 862 of file unordered_set.h.

## size()

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

size_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::size | ( |  | ) | const

inline noexcept

Returns the size of the unordered_set.

Definition at line 306 of file unordered_set.h.

## swap()

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>

void std::unordered_set< _Value, _Hash, _Pred, _Alloc >::swap | ( | unordered_set< _Value, _Hash, _Pred, _Alloc > & | __x | ) |

inline noexcept

Swaps data with another unordered_set.

Parameters

  __x | An unordered_set of the same element and allocator types.

This exchanges the elements between two sets in constant time. Note that the global std::swap() function is specialized such that std::swap(s1,s2) will feed to this function.

Definition at line 588 of file unordered_set.h.

## Friends And Related Symbol Documentation

## std::_Hash_merge_helper

template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>
template<typename , typename , typename >

friend class std::_Hash_merge_helper

friend

Definition at line 594 of file unordered_set.h.

The documentation for this class was generated from the following file:

- unordered_set.h